#include "stdafx.h"
#include "FileOperate.h"
#include <filesystem>
#include <stdio.h>

FileOperate::FileOperate()
{}

FileOperate::FileOperate(const std::string &file) : mFile(file)
{}

FileOperate::~FileOperate()
{
	if (mFileStream.is_open()) {
		close();
	}
}

/*
 * ļ
 */
bool FileOperate::create(const std::string &file)
{
	std::fstream out_file;
	out_file.open(file.c_str(), std::ios::out);
	if (!out_file) {
		return false;
	}
	out_file.close();

	return true;
}

/*
 * ɾļ
 */
bool FileOperate::remove(const std::string &file)
{
	// ɾļɹ0򷵻-1
	if (-1 == std::remove(file.c_str())) {
		return false;
	}

	return true;
}

bool FileOperate::exist(const string &file)
{
	if (std::filesystem::exists(file))
		return true;

	return false;
}

bool FileOperate::open(ios_base::openmode __mode)
{
	mFileStream.open(mFile.c_str(), __mode);

	return mFileStream.is_open();
}

bool FileOperate::open(const string &file, ios_base::openmode __mode)
{
	mFile = file;
	return open(__mode);
}

void FileOperate::close()
{
	mFileStream.close();
	mFileStream.clear();
}

/*
 * ļ
 */
bool FileOperate::rename(const std::string &newName)
{
	std::string newFile = fileDir() + newName;

	int result = std::rename(mFile.c_str(), newFile.c_str());
	if (result == 0)
		return true;

	return false;
}

/*
 * жļǷ
 */
bool FileOperate::isExist()
{
	return FileOperate::exist(mFile);
}

/*
 * ȡļ
 * ļ· /home/root/.../Test/test1.txt
 * ֵ      test1.txt
 */
const string FileOperate::fileName()
{
	string name = mFile;

	std::size_t pos = mFile.rfind('/');
	if (pos != std::string::npos) {
		name = mFile.substr(pos + 1);
	}

	return name;
}

/*
 * ȡļĿ¼
 * ļ· /home/root/.../Test/test1.txt
 * ֵ      /home/root/.../Test/
 */
const string FileOperate::fileDir()
{
	string dir = "";

	std::size_t pos = mFile.rfind('/');
	if (pos != std::string::npos) {
		dir = mFile.substr(0, pos + 1);
	}

	return dir;
}

/*
 * ȡļС(ֽ)
 */
size_t FileOperate::fileSize()
{
#if 0
	// ʽһ
	mFileStream.seekg(0, mFileStream.end);
	int length = mFileStream.tellg();
	mFileStream.seekg(0, mFileStream.beg);

	return length;
#endif

	// ʽ
	struct stat info;
	stat(mFile.c_str(), &info);

	return static_cast<std::size_t>(info.st_size);
}

bool FileOperate::atEnd()
{
	// peekǻȡһַָ벻ƶ
	return mFileStream.peek() == EOF;
}

void FileOperate::read(string &buffer, size_t bufferSize)
{
	buffer.resize(bufferSize);
	mFileStream.read(&buffer[0], bufferSize);
}

const string FileOperate::readLine()
{
	// ļ ȡ
	std::string dataStr = "";
	getline(mFileStream, dataStr);
	return dataStr;
}

const string FileOperate::readAll()
{
	std::string buffer;
	size_t length = fileSize();
	FileOperate::read(buffer, length);

	return buffer;
}

void FileOperate::write(const string &data)
{
	mFileStream << data << '\n';
}
