#pragma once
// FileOperate.h
#ifndef FILEOPERATE_H
#define FILEOPERATE_H

#include <iostream>
#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fstream>
 

using namespace std;

class FileOperate
{
public:
	FileOperate();
	FileOperate(const std::string& file);
	~FileOperate();

	// ļ
	static bool create(const std::string &file);

	// ɾļ
	static bool remove(const std::string &file);

	// ļǷ
	static bool exist(const std::string &file);

	// ļ
	bool open(ios_base::openmode __mode = std::fstream::in | std::fstream::out);
	bool open(const std::string &file, ios_base::openmode __mode = std::fstream::in | std::fstream::out);

	// رļ
	void close();

	// ļ
	bool rename(const std::string &newName);

	// ļǷ
	bool isExist();

	// ȡļ
	const std::string fileName();

	// ȡļĿ¼
	const std::string fileDir();

	// ȡļС(ֽ)
	std::size_t fileSize();

	// жϵǰַǷ
	bool atEnd();

	// ȡļ
	void read(std::string &buffer, size_t bufferSize);
	const std::string readLine();
	const std::string readAll();

	// дݵļ
	void write(const std::string &data);

private:
	std::string mFile;
	std::fstream mFileStream;
};

#endif // FILEOPERATE_H



/*
 *
 // ʽһ
FileOperate mFileOperate("/home/Test/Test1.txt");
if (!mFileOperate.open(std::fstream::in | std::fstream::out | std::fstream::app)) {
    cout << "ļʧ" << endl;
    return 0;
}

// ʽ
FileOperate mFileOperate;
std::string fileStr = "/home/Test/Test1.txt";
if (!mFileOperate.open(fileStr, std::fstream::in | std::fstream::out | std::fstream::app)) {
    cout << "ļʧ" << endl;
    return 0;
}


FileOperate mFileOperate("/home/Test/Test1.txt");
// ȡļ
cout << mFileOperate.fileName() << endl;  //  Test1.txt

// ȡļĿ¼
cout << mFileOperate.fileDir() << endl;   //  /home/xushuan/Test/

// ȡļС
cout << mFileOperate.fileSize() << endl;


// ʽһ һһжȡ
std::string data;
while (!mFileOperate.atEnd()) {
	data = mFileOperate.readLine();
}

// ʽ  ȡָֽڴС
std::string data;
mFileOperate.read(data, 100);

// ʽ  һȫȡ
	// ʽһ
	std::string data = mFileOperate.readAll();

	// ʽ
	string data;
	mFileOperate.read(data, mFileOperate.fileSize());


	// дݵļ
mFileOperate.write("hello");

 *
 *
 ***/