#pragma once
#ifndef _SYSMODULE_
#define _SYSMODULE_

#ifndef SYSMODULE
#define SYSMODULE extern "C" _declspec(dllexport)
#else
#undef SYSMODULE
#define SYSMODULE extern "C" _declspec(dllimport)
#endif

#define CLSID_BASEMODULE L"{DA90D68D-99EB-45D5-A969-BC3D0D12D92A}"

#pragma pack(push,1)

class IBaseCurl;
//ȡָ
class IBaseGloablModule
{
public:
	virtual ~IBaseGloablModule(void) {}

	////ȡϢ
	//virtual LPCSTR  GetLastErrorA() = 0;
	//virtual LPCWSTR GetLastErrorW() = 0;

	virtual IBaseCurl* GetBaseCurlInstance() = 0;
 

	virtual INT AddRef() = 0;
	virtual INT Release() = 0;
};

template<typename T>
class IInstanceList
{
public:
	IInstanceList(void)
	{
		m_pNext = NULL;
		m_pPrev = NULL;
	}
	virtual ~IInstanceList(void)
	{
		Detach();
	}

	virtual void AddInstance(T* pInstance)
	{
		if (m_pNext && (m_pNext != pInstance))
			m_pNext->AddInstance(pInstance);
		else
		{
			pInstance->m_pPrev = (T*)this;
			m_pNext = pInstance;
		}
	}

	virtual void Detach()
	{
		if (m_pNext)
			m_pNext->m_pPrev = m_pPrev;
		if (m_pPrev)
			m_pPrev->m_pNext = m_pNext;

		m_pPrev = m_pNext = NULL;
	}

	T* m_pPrev;
	T* m_pNext;
};

class IServerListCallback
{
public:
	virtual ~IServerListCallback(void) {};

	virtual void ServerListCallback() = 0;
};


enum HTTPRET
{
	http_no = 0,
	http_f,
	http_yes,
	http_start,
	http_end,
};
//ӿ
class IBaseCurl
	: public IInstanceList<IBaseCurl>
{
public:
	virtual ~IBaseCurl(void) {};
	virtual HTTPRET GetHttpConnectstatus() = 0;

	virtual LPCSTR  GetLastErrorA() = 0;
};

SYSMODULE IBaseGloablModule* WINAPI GetBaseGlobalInstance();
SYSMODULE BOOL WINAPI ReleaseBaseGlobalInstance();

#pragma pack(pop)

#endif